% demo code for loading places205-AlexNet and do scene attribute prediction
% download the Places205-AlexNet at http://places.csail.mit.edu/model/placesCNN_upgraded.tar.gz

% Bolei Zhou
addpath('caffe/matlab');
load('sceneAttributeModel205.mat');
caffe.set_mode_cpu();

% initialize model
net_model = 'places205CNN_deploy_upgraded.prototxt';
net_weights = 'places205CNN_iter_300000_upgraded.caffemodel';
phase = 'test';
net = caffe.Net(net_model, net_weights, phase);

% Test img
im = imread('8.jpg');

input_data = {prepare_image(im)};
scores = net.forward(input_data);
feat_FC7_batch = net.blobs('fc7').get_data();
feat_FC7_single = mean(feat_FC7_batch,2)

scores = scores{1};
scores = mean(scores, 2);  % take average scores over 10 crops
[scores_sort, IDX_sort] = sort(scores,'descend');
disp('--------------------- scene classification-------')
for i=1:5
        disp(sprintf('top %d scene prediction:%s', i, categories{IDX_sort(i),1}));
end

% compute the scene attribute response
response_attribute = W_sceneAttribute*feat_FC7_single;
[response_sort, IDXattribute_sort] = sort(response_attribute,'descend');
disp('--------------------- attribute prediction------')
for i=1:10
        disp(sprintf('top %d attribute:%s', i, attributes{IDXattribute_sort(i)}));
end
figure,imshow(im)
caffe.reset_all();
